<?php


 
// Работаем в корневой директории
chdir ('../../');
require_once('api/Okay.php');
$okay = new Okay();

/**
   * Checked signature.
   * 
   * @param type $post
   * @param type $sign
   * @return boolean
   */
  function checkSig($post, $sign) {
    foreach ($post as $key => $value) {
      if($key == 'route') {
        continue;
      }
      if ($key !== "WMI_SIGNATURE") {
        $params[$key] = urldecode($value);
      }
    }
    uksort($params, "strcasecmp");

    $values = "";
    foreach ($params as $name => $value) {
      $values .= $value;
    }
    $signature = base64_encode(pack("H*", md5($values . $sign)));
    if ($signature == urldecode($post['WMI_SIGNATURE'])) {
      return true;
    }
    return false;
  }


// Выберем заказ
$order = $okay->orders->get_order((int) str_replace('_' . $_SERVER['HTTP_HOST'], '', $_POST['WMI_PAYMENT_NO']));
if (empty($order)) {
  die('WMI_RESULT=RETRY&WMI_DESCRIPTION=Такого номера заказа не существует');
}
// Нельзя оплатить уже оплаченный заказ  
if($order->paid) {
  die('WMI_RESULT=RETRY&WMI_DESCRIPTION=Этот заказ уже оплачен');
}

// Выбираем из базы соответствующий метод оплаты
$payment_method = $okay->payment->get_payment_method(intval($order->payment_method_id));
if(empty($payment_method)) {
  die("WMI_RESULT=RETRY&WMI_DESCRIPTION=Неизвестный метод оплаты");
}

$payment_settings = $okay->payment->get_payment_settings($payment_method->id);
if (!checkSig($_POST, $payment_settings['WMI_SIGNATURE'])) {
  die('WMI_RESULT=RETRY&WMI_DESCRIPTION=Ошибка подписи');
}

$post = array();
foreach ($_POST as $key => $val) {
  if ($key == 'route') {
    continue;
  }
  if ($key != 'WMI_FAIL_URL' && $key != 'WMI_SUCCESS_URL' && $key != 'WMI_SIGNATURE' && $key != 'WMI_DESCRIPTION' && preg_match('/^[a-z0-9\._\-\: ]+$/ui', urldecode($val))) {
    $post[$key] = htmlentities(urldecode($val));
    if (strlen($post[$key]) > 250) {
      $post[$key] = substr($post[$key], 0, 250);
    }
  }
  elseif (($key == 'WMI_FAIL_URL' || $key == 'WMI_SUCCESS_URL') && preg_match('/^[a-z0-9\._\-\:\/\&\?=]+$/ui', urldecode($val))) {
    $post[$key] = htmlentities(urldecode($val));
    if (strlen($post[$key]) > 500) {
      $post[$key] = substr($post[$key], 0, 500);
    }
  }
  elseif ($key == 'WMI_SIGNATURE' && preg_match('/^[a-z0-9\._\-\+\=\/\\\]+$/ui', urldecode($val))) {
    $post[$key] = htmlentities(urldecode($val));
    if (strlen($post[$key]) > 500) {
      $post[$key] = substr($post[$key], 0, 500);
    }
  }
  elseif ($key == 'WMI_DESCRIPTION') {
    if (!empty($_SERVER['HTTP_USER_AGENT']) && preg_match('/^[a-zа-яё0-9№\. ]+$/ui', mb_convert_encoding(urldecode($val), "UTF-8", "Windows-1251"))) {
      $post[$key] = htmlentities(mb_convert_encoding(urldecode($val), "UTF-8", "Windows-1251"));
    }
    elseif (preg_match('/^[a-zа-яё0-9№\. ]+$/ui', mb_convert_encoding(urldecode($val), "UTF-8", "Windows-1251"))) {
      $post[$key] = htmlentities(mb_convert_encoding(urldecode($val), "UTF-8", "Windows-1251"));
    }
  }
}

if (empty($post)) {
  die('WMI_RESULT=RETRY&WMI_DESCRIPTION=Не корректный запрос');
}

$price = $okay->money->convert($order->total_price, $payment_method->currency_id, false);
if ($post['WMI_PAYMENT_AMOUNT'] != number_format($price, 2, '.', '')) {
  die('WMI_RESULT=RETRY&WMI_DESCRIPTION=Не верная сумма заказа');
}

// Проверка наличия товара
$purchases = $okay->orders->get_purchases(array('order_id'=>intval($order->id)));
foreach($purchases as $purchase)
{
	$variant = $okay->variants->get_variant(intval($purchase->variant_id));
	if(empty($variant) || (!$variant->infinity && $variant->stock < $purchase->amount))
	{
		die("WMI_RESULT=RETRY&WMI_DESCRIPTION=Нехватка товара $purchase->product_name $purchase->variant_name");
	}
}

if(mb_strtolower($post['WMI_ORDER_STATE']) == 'accepted'){
    // Установим статус оплачен
  $okay->orders->update_order(intval($order->id), array('paid' => 1));

  // Спишем товары  
  $okay->orders->close(intval($order->id));
  $okay->notify->email_order_user(intval($order->id));
  $okay->notify->email_order_admin(intval($order->id));
  die("WMI_RESULT=OK");
}

die("WMI_RESULT=RETRY&WMI_DESCRIPTION=Error");
