<?php


require_once('api/Okay.php');

class W1 extends Okay {

  public function checkout_form($order_id, $button_text = null) {
    if(empty($_POST['WMI_ORDER_ID'])){
      if (empty($button_text)) {
        $button_text = 'Перейти к оплате';
      }

      $order = $this->orders->get_order((int) $order_id);
      $payment_method = $this->payment->get_payment_method($order->payment_method_id);
      $payment_settings = $this->payment->get_payment_settings($payment_method->id);
      $price = $this->money->convert($order->total_price, $payment_method->currency_id, false);
        $key = $payment_settings['WMI_SIGNATURE'];
    $date = strtotime("+7 day", time());
      $fields = array();
      $fields['WMI_MERCHANT_ID'] = $payment_settings['WMI_MERCHANT_ID'];
      $fields['WMI_PAYMENT_AMOUNT'] = number_format($price, 2, '.', '');
      $fields['WMI_CURRENCY_ID'] = $payment_settings['WMI_CURRENCY_ID'];
      $fields['WMI_PAYMENT_NO'] = $order->id.'_'.$_SERVER['HTTP_HOST'];
      $fields['WMI_DESCRIPTION'] = 'BASE64:'.base64_encode('Оплата заказа №'.$order->id);
        $fields["WMI_EXPIRED_DATE"] = date('c',$date);
      $fields['WMI_SUCCESS_URL'] = $this->config->root_url . '/order/' . $order->url;
      $fields['WMI_FAIL_URL'] = $this->config->root_url . '/order/' . $order->url;



      if(!empty($order->email)){
          $fields['WMI_CUSTOMER_EMAIL'] = $order->email;
          $fields['WMI_RECIPIENT_LOGIN'] = $order->email;
          $fields['CMS'] = 'OkayCMS';
      }
        $fields['ZZZ'] = 'К оплате';

        //Сортировка значений внутри полей
        foreach($fields as $name => $val)
        {
            if(is_array($val))
            {
                usort($val, "strcasecmp");
                $fields[$name] = $val;
            }
        }

// Формирование сообщения, путем объединения значений формы,
// отсортированных по именам ключей в порядке возрастания.
        uksort($fields, "strcasecmp");
        $fieldValues = "";

        foreach($fields as $value)
        {
            if(is_array($value))
                foreach($value as $v)
                {
//Конвертация из текущей кодировки (UTF-8)
//необходима только если кодировка магазина отлична от Windows-1251
                    $v = iconv("utf-8", "windows-1251", $v);
                    $fieldValues .= $v;
                }
            else
            {
//Конвертация из текущей кодировки (UTF-8)
//необходима только если кодировка магазина отлична от Windows-1251
                $value = iconv("utf-8", "windows-1251", $value);
                $fieldValues .= $value;
            }
        }

// Формирование значения параметра WMI_SIGNATURE, путем
// вычисления отпечатка, сформированного выше сообщения,
// по алгоритму MD5 и представление его в Base64

        $signature = base64_encode(pack("H*", md5($fieldValues . $key)));

//Добавление параметра WMI_SIGNATURE в словарь параметров формы

        $fields["WMI_SIGNATURE"] = $signature;

      $html = '<form name="pay" method="POST" action="https://wl.walletone.com/checkout/checkout/Index">
      <input type="hidden" name="CMS" value="'.$fields['CMS'].'">
      <input type="hidden" name="WMI_CURRENCY_ID" value="'.$fields['WMI_CURRENCY_ID'].'">';
      if(!empty($fields['WMI_CUSTOMER_EMAIL'])) {
        $html .= '<input type="hidden" name="WMI_CUSTOMER_EMAIL" value="'.$fields['WMI_CUSTOMER_EMAIL'].'">';
      }
      $html .= '<input type="hidden" name="WMI_DESCRIPTION" value="'.$fields['WMI_DESCRIPTION'].'">
      <input type="hidden" name="WMI_EXPIRED_DATE" value="'.$fields['WMI_EXPIRED_DATE'].'">
      <input type="hidden" name="WMI_FAIL_URL" value="'.$fields['WMI_FAIL_URL'].'">
      <input type="hidden" name="WMI_MERCHANT_ID" value="'.$fields['WMI_MERCHANT_ID'].'">
      <input type="hidden" name="WMI_PAYMENT_AMOUNT" value="'.$fields['WMI_PAYMENT_AMOUNT'].'">
      <input type="hidden" name="WMI_PAYMENT_NO" value="'.$fields['WMI_PAYMENT_NO'].'">';
      if(!empty($fields['WMI_RECIPIENT_LOGIN'])) {
        $html .= '<input type="hidden" name="WMI_RECIPIENT_LOGIN" value="'.$fields['WMI_RECIPIENT_LOGIN'].'">';
      }
      $html .= '<input type="hidden" name="WMI_SUCCESS_URL" value="'.$fields['WMI_SUCCESS_URL'].'">';

      $html .= '<input type="hidden" name="WMI_SIGNATURE" value="'.$fields['WMI_SIGNATURE'].'">
        <input type="submit" class="checkout_button" value="'.$button_text.'">
      </form>';
    }
    else{
      
      $html = '';
      $order = $this->orders->get_order((int)str_replace('_'.$_SERVER['HTTP_HOST'], '', $_POST['WMI_PAYMENT_NO']));
      if(empty($order)){
        return '<p style="color:#FF0000">Такого номера заказа не существует.</p>';
      }
      $payment_method = $this->payment->get_payment_method($order->payment_method_id);
      $payment_settings = $this->payment->get_payment_settings($payment_method->id);
      
      if (!$this->checkSig($_POST, $payment_settings['WMI_SIGNATURE'])) {
        return '<p style="color:#FF0000;font-size:150%">Ошибка подписи.</p>';
      }

      $post = array();
      foreach ($_POST as $key => $val) {
        if ($key == 'route') {
          continue;
        }
        if ($key != 'WMI_FAIL_URL' && $key != 'WMI_SUCCESS_URL' && $key != 'WMI_SIGNATURE' && $key != 'WMI_DESCRIPTION' && preg_match('/^[a-z0-9\._\-\: ]+$/ui', urldecode($val))) {
          $post[$key] = htmlentities(urldecode($val));
          if (strlen($post[$key]) > 250) {
            $post[$key] = substr($post[$key], 0, 250);
          }
        }
        elseif (($key == 'WMI_FAIL_URL' || $key == 'WMI_SUCCESS_URL') && preg_match('/^[a-z0-9\._\-\:\/\&\?=]+$/ui', urldecode($val))) {
          $post[$key] = htmlentities(urldecode($val));
          if (strlen($post[$key]) > 500) {
            $post[$key] = substr($post[$key], 0, 500);
          }
        }
        elseif ($key == 'WMI_SIGNATURE' && preg_match('/^[a-z0-9\._\-\+\=\/\\\]+$/ui', urldecode($val))) {
          $post[$key] = htmlentities(urldecode($val));
          if (strlen($post[$key]) > 500) {
            $post[$key] = substr($post[$key], 0, 500);
          }
        }
        elseif ($key == 'WMI_DESCRIPTION') {
          if (!empty($_SERVER['HTTP_USER_AGENT']) && preg_match('/^[a-zа-яё0-9№\. ]+$/ui', mb_convert_encoding(urldecode($val), "UTF-8", "Windows-1251"))) {
            $post[$key] = htmlentities(mb_convert_encoding(urldecode($val), "UTF-8", "Windows-1251"));
          }
          elseif (preg_match('/^[a-zа-яё0-9№\. ]+$/ui', mb_convert_encoding(urldecode($val), "UTF-8", "Windows-1251"))) {
            $post[$key] = htmlentities(mb_convert_encoding(urldecode($val), "UTF-8", "Windows-1251"));
          }
        }
      }
      
      if (empty($post)) {
        return '<p style="color:#FF0000;font-size:150%">Не корректный запрос.</p>';
      }
      
      $price = $this->money->convert($order->total_price, $payment_method->currency_id, false);
      if($post['WMI_PAYMENT_AMOUNT'] != number_format($price, 2, '.', '')){
        return '<p style="color:#FF0000;font-size:150%">Не верная сумма заказа.</p>';
      }
      // Проверка наличия товара
      $purchases = $this->orders->get_purchases(array('order_id'=>intval($order->id)));
      foreach($purchases as $purchase)
      {
        $variant = $this->variants->get_variant(intval($purchase->variant_id));
        if(empty($variant) || (!$variant->infinity && $variant->stock < $purchase->amount))
        {
          return '<p style="color:#FF0000;font-size:150%">Нехватка товара '.$purchase->product_name.' '.$purchase->variant_name.'</p>';
        }
      }
      $status = mb_strtolower($post['WMI_ORDER_STATE']);
      switch ($status) {
        case "accepted":
          return '<p style="color:#008000;font-size:150%">Заказ оплачен.</p>';
          break;
        case "created":
          return '<p style="font-size:150%">Заказ ожидает оплаты.</p>';
          break;
        default:
          return '<p style="color:#FF0000;font-size:150%">Заказ не оплачен.</p>';
          break;
      }
    }

      $res['fields'] = $fields;
    
    return $res;
  }
  
  
  /**
   * Checked signature.
   * 
   * @param type $post
   * @param type $sign
   * @return boolean
   */
  private function checkSig($post, $sign) {
    foreach ($post as $key => $value) {
      if($key == 'route') {
        continue;
      }
      if ($key !== "WMI_SIGNATURE") {
        $params[$key] = urldecode($value);
      }
    }
    uksort($params, "strcasecmp");

    $values = "";
    foreach ($params as $name => $value) {
      $values .= $value;
    }
    $signature = base64_encode(pack("H*", md5($values . $sign)));
    if ($signature == urldecode($post['WMI_SIGNATURE'])) {
      return true;
    }
    return false;
  }

}
